#pragma once
#include "IControl.h"
#include "ISingleControl.h"
#include "IMultipleControlContainer.h"

enum {
	ATTACK = 0,
	DECAY, 
	SUSTAIN,
	RELEASE,
	NUMBER_OF_POINTS
};


class IADSREnvelope : public IMultipleControlContainer
{
	friend class IADSROneValue;
public:
	IADSREnvelope(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn, IGraphics* pGraphics, IRECT rect, int numerOfTab, int index, int* attackIds, int* nrpnAttackParams);
	~IADSREnvelope(void);

	void computeRect();
	void SetDirty(int whichValue);

    bool Draw(IGraphics* pGraphics);
	void OnMouseDown(int x, int y, IMouseMod* pMod);
	void OnMouseDrag(int x, int y, int dX, int dY, IMouseMod* pMod);
	void OnMouseUp(int x, int y, IMouseMod* pMod);
	bool setCurrentTab(int newTab);

	void setValueFromHardware(int tab, int controlNumber, int nrpnValue);

	int getNrpnParam(int currentTab, int controlNumber) ;
	int getParamId(int currentTab, int controlNumber) ;
	float getFloatFromNrpn(int nrpnValue) ;
	float getFloatFromInternal(int intValue) ;
	int   getInternalFromFloat(float value) ;
	int   getNrpnFromInternal(int intValue) ;

	// Debug
	void flushNrpn();
private:
	IRECT rect[NUMBER_OF_POINTS];
	int height;
	int sizeDiv4;
	int drag ;
	IRECT insideRect;
	int* attackIds;
	int* nrpnAttackParams;
};
