#include "IButtonSwitch.h"


IButtonSwitch::IButtonSwitch(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn,IGraphics* pGraphics, IRECT rect, int numberOfTab, const char*vstName, int* paramIds, int* nrpnParams, const char**controlNames)
	:  ISingleControlContainer(pPlugBase, pPlugNrpn, rect, numberOfTab,  paramIds, nrpnParams)
{
	char buf[30];

	for (int k=0; k<numberOfTab; k++) {
		singleControls[k] = new ISingleControl(k, pPlugBase, this, paramIds[k]);
		pGraphics->AttachControl(singleControls[k]);
		sprintf(buf,vstName, k+1);
		mPlug->GetParam(paramIds[k])->InitInt(buf, 0, 0, 1, "");
	}
	
	this->controlNames = new char*[2];
	for (int k=0; k<2; k++) {
		this->controlNames[k] = new char[30];
		strcpy(this->controlNames[k], controlNames[k]);
	}
}

IButtonSwitch::~IButtonSwitch(void)
{
}

bool IButtonSwitch::Draw(IGraphics* pGraphics) {
	IRECT textRect1 = IRECT(mRECT.L, mRECT.T, mRECT.R, mRECT.T+12);
	int sizeX = mRECT.R - mRECT.L;
	int sizeY = (mRECT.B - mRECT.T) / 3;
	int sizeButton = sizeX/4;
	IText itext1(12, &yellow);
	IText itext2(12, &gray);
	IRECT drawRECT = IRECT(mRECT.L, mRECT.T + sizeY, mRECT.R, mRECT.B - sizeY);
	IRECT textRect2 = IRECT(mRECT.L, mRECT.B-12, mRECT.R, mRECT.B);
	
	if (this->currentValues[this->currentTab] == 0) {		
		pGraphics->DrawIText(&itext1, this->controlNames[0], &textRect1);
	} else {
		pGraphics->DrawIText(&itext2, this->controlNames[0], &textRect1);
	}

	pGraphics->DrawRect(&white, &drawRECT);
	
	IRECT buttonRECT;	
	if (this->currentValues[this->currentTab] == 1) {		
		pGraphics->DrawIText(&itext1, this->controlNames[1], &textRect2);
		buttonRECT = IRECT(drawRECT.R-sizeButton, drawRECT.T+2, drawRECT.R-1, drawRECT.B-1);
	} else {
		pGraphics->DrawIText(&itext2, this->controlNames[1], &textRect2);
		buttonRECT = IRECT(drawRECT.L+2, drawRECT.T+2, drawRECT.L+1+sizeButton, drawRECT.B-1);
	}
	pGraphics->FillIRect(&yellow, &buttonRECT);

	return true;
}

void IButtonSwitch::OnMouseDown(int x, int y, IMouseMod* pMod) {
	if (this->currentValues[this->currentTab] == 0) {
		this->currentValues[this->currentTab] = 1;
	} else {
		this->currentValues[this->currentTab] = 0;
	}
	SetDirty(true);
	Redraw();
}

// implement abstract methods
float IButtonSwitch::getFloatFromNrpn(int nrpnValue)  {
	return (float)nrpnValue;
}

float IButtonSwitch::getFloatFromInternal(int intValue) {
	return (float)intValue;
}

int   IButtonSwitch::getInternalFromFloat(float value) {
	return (int) value >.5 ? 1 : 0;
}

int   IButtonSwitch::getNrpnFromInternal(int intValue) {
	return intValue;
}
