#pragma once

#include "ISingleControl.h"
#include "ISingleControlContainer.h"

class IControlSwitch :
	public ISingleControlContainer
{
public:
	IControlSwitch(IPlugBase* pPlugBase,IPlugNrpn* pPlugNrpn, IGraphics* pGraphics, IRECT rect, const char* name, int* paramIds, int numberOfTabs, int numberOfControl, const char**controlNames, ISingleControlContainerBase**controlsToSwitch);
	~IControlSwitch(void);
    bool Draw(IGraphics* pGraphics);
	void OnMouseDown(int x, int y, IMouseMod* pMod);
	bool setCurrentTab(int newTab);

	void setValueFromHardware(int tab, int controlNumber, int nrpnValue);

	float getFloatFromNrpn(int nrpnValue);
	float getFloatFromInternal(int intValue);
	int   getInternalFromFloat(float value) ;
	int   getNrpnFromInternal(int intValue) ;

protected:
	void updateControlVisibility();

private:
	int numberOfControls;
	ISingleControlContainerBase**controlsToSwitch;
	char **controlNames;
};
