#pragma once

#include "ISingleControl.h"
#include "ISingleControlContainer.h"

enum DisplayType {
	DISPLAY_FLOAT_3_5,
	DISPLAY_FLOAT_4_4,
	DISPLAY_FLOAT_5_3,
	DISPLAY_FLOAT_1_7,
	DISPLAY_CHAR,
	DISPLAY_UCHAR
};

#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif

class IKnob : public ISingleControlContainer
{
public:
	IKnob(IPlugBase* pPlugBase,IPlugNrpn* pPlugNrpn, IGraphics* pGraphics, IRECT rect, int numberOfTab, const char*vstName, int* paramIds, int* nrpnParams, int nrpnMinValue, int nrpnMaxValue, int nrpnDefaultValue, DisplayType displayType, int* accurateNumber = NULL
		, int nStringNumber = 0, const char** strings = NULL);
    bool Draw(IGraphics* pGraphics);
	void OnMouseDown(int x, int y, IMouseMod* pMod);
	void OnMouseDrag(int x, int y, int dX, int dY, IMouseMod* pMod);
	void OnMouseUp(int x, int y, IMouseMod* pMod);
	void OnMouseWheel(int x, int y, IMouseMod* pMod, int d);
	void OnMouseDblClick(int x, int y, IMouseMod* pMod);

	float getFloatFromNrpn(int nrpnValue);
	float getFloatFromInternal(int intValue);
	int   getInternalFromFloat(float value) ;
	int   getNrpnFromInternal(int intValue) ;

	
private:
	bool draging;
	bool slowDrag;
	DisplayType displayType;
	int dragX, dragY, dragValue;
	int nrpnMaxValue, nrpnMinValue, nrpnDefaultValue;
	float cx, cy, r;
	int numberOfStrings;
	char** strings;

};

