#include "IMultipleControlContainer.h"


IMultipleControlContainer::IMultipleControlContainer(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn, IRECT rect, int numberOfTab, int numberOfControls)
	: ISingleControlContainerBase(pPlugBase, pPlugNrpn, rect, numberOfTab)
{
	this->numberOfControls =numberOfControls ;
	this->currentValues = new int*[numberOfTab];
	this->singleControls = new ISingleControl**[numberOfTab];

	for (int k=0; k<numberOfTab; k++) {
		this->currentValues[k] = new int[numberOfControls];
		this->singleControls[k] = new ISingleControl*[numberOfControls];
	}


}


IMultipleControlContainer::~IMultipleControlContainer(void)
{
}

void IMultipleControlContainer::SetDirty(int whichValue) {
	mDirty = true;
	Redraw();
	if (whichValue != -1) {
		double normalizedValue =  getFloatFromInternal(currentValues[currentTab][whichValue]);
		// singleControls[currentTab][whichValue]->SetValueFromUserInput(normalizedValue);
		nrpnPlug->sendNrpn(getNrpnParam(currentTab, whichValue), currentValues[currentTab][whichValue]);
		mPlug->SetParameterFromGUI(getParamId(currentTab, whichValue), normalizedValue);
	}
}


void IMultipleControlContainer::setValueFromAutomation(int controlNum, double value) {
	int tab = controlNum / numberOfControls;
	int cn = controlNum - tab * numberOfControls;

	int newValue = getInternalFromFloat(value);
	if (currentValues[tab][cn] != newValue  || this->nrpnPlug->isInitializing()) {
		currentValues[tab][cn] = newValue;
		nrpnPlug->sendNrpn(getNrpnParam(tab, cn), getNrpnFromInternal(newValue));
		if (tab == currentTab) {
			SetDirty(-1);
		}
	}
}


void IMultipleControlContainer::setValueFromHardware(int tab, int controlNumber, int nrpnValue)
{
	float value = getFloatFromNrpn(nrpnValue);
	// singleControls[tab][controlNumber]->SetValueFromUserInput(value);
	currentValues[tab][controlNumber] = getInternalFromFloat(value);
	mPlug->SetParameterFromGUI(getParamId(tab, controlNumber), value);
	if (tab == currentTab) {
		mDirty = true;
	    Redraw();
	}
}

void IMultipleControlContainer::flushNrpn() {
	for (int tab=0; tab<numberOfTab; tab++) {
		for (int cn=0; cn<numberOfControls; cn++) {
			nrpnPlug->sendNrpn(getNrpnParam(tab, cn), getNrpnFromInternal(currentValues[tab][cn]) );
		}
	}
}
