#pragma once

#include "IControl.h"
#include "ISingleControl.h"
#include "ISingleControlContainer.h"

class IOverlaySelect : public ISingleControlContainer
{
public:
	IOverlaySelect(IPlugBase* pPlugBase,IPlugNrpn* pPlugNrpn, IGraphics* pGraphics,  IRECT rect, int numberOfTabs, const char*vstName, int* paramIds, int* nrpnParams, int numberOfValues, int* nrpnValues, const char**valueLabels, int* accurateNumber = NULL);
    bool Draw(IGraphics* pGraphics);
	void OnMouseDown(int x, int y, IMouseMod* pMod);
	void OnMouseWheel(int x, int y, IMouseMod* pMod, int d);

	float getFloatFromNrpn(int nrpnValue);
	float getFloatFromInternal(int intValue);
	int   getInternalFromFloat(float value) ;
	int   getNrpnFromInternal(int intValue) ;
private:
	IRECT valueRECT, overlayRECT, fullRECT;
	int* nrpnValues;
	int numberOfValues;
	char **valueLabels;
	bool overlayed;
	int cellSizeY;
};

