#include "IPresetNameControl.h"

IPresetNameControl::IPresetNameControl(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn,  IRECT pR, int paramIdx, IText* pText)
	:   ITextControl(pPlugBase, pR, pText)
{
    this->mParamIdx = paramIdx;
	this->mDisablePrompt = false;
	this->nrpnPlug = pPlugNrpn;
	this->mTextEntryLength = 12;
}

void IPresetNameControl::OnMouseDown(int x, int y, IMouseMod* pMod)
{
	int editW = 160;
	int editH = 22;
	if (pMod->L || pMod->R) {
		char text[12];
		int cX = (int) mRECT.MW() + 2 ;
		int cY = (int) mRECT.MH() + 2;
		IRECT txtRECT = IRECT(cX - (float) editW/2., cY - (editH / 2.), cX + (float) editW/2. -1, cY + (editH / 2.) -1 ); 
		// mPlug->GetGUI()->PromptUserInput(this, mPlug->GetParam(mParamIdx), &txtRECT );
		mPlug->GetGUI()->CreateTextEntry(this, &mText, &txtRECT, mStr.Get() );
	}

}

void IPresetNameControl::OnMouseDblClick(int x, int y, IMouseMod* pMod)
{
	OnMouseDown(x, y, pMod);
}

bool IPresetNameControl::Draw(IGraphics* pGraphics)
{
    return ITextControl::Draw(pGraphics);
}

void IPresetNameControl::TextFromTextEntry( const char* txt ) { 
  if (strcmp(mStr.Get(), txt))
  {
	mStr.Set(txt); 
	SetDirty();
	for (int k=0; k<12; k++) {
		nrpnPlug->sendNrpn(228 + k, txt[k] );
	}
  }
}

void IPresetNameControl::SetTextFromPlug(char* str) {
	TextFromTextEntry(str);
}


const char* IPresetNameControl::getName() {
	return mStr.Get();
}