
#include "ISingleControlContainerBase.h"


const IColor ISingleControlContainerBase::darkBlue = IColor(255,82,105,140);
const IColor ISingleControlContainerBase::white = IColor(255,255,255,255);
const IColor ISingleControlContainerBase::darkYellow = IColor(255,180,180,100);
const IColor ISingleControlContainerBase::yellow = IColor(255,240,180,30);
const IColor ISingleControlContainerBase::gray = IColor(255,150,150,150);
const IColor ISingleControlContainerBase::shadow = IColor(220,20,30,40);

ISingleControlContainerBase::ISingleControlContainerBase(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn, IRECT rect, int numberOfTab) : IControl(pPlugBase, rect)
{
	this->currentTab = 0;
	this->numberOfTab = numberOfTab;
	this->nrpnPlug = pPlugNrpn;
}


ISingleControlContainerBase::ISingleControlContainerBase(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn,  int x, int y, IBitmap* pBitmap, int numberOfTab) : IControl( pPlugBase, IRECT(x, y, pBitmap)),  mBitmap(*pBitmap) {
	this->currentTab = 0;
	this->numberOfTab = numberOfTab;
	this->nrpnPlug = pPlugNrpn;
}


bool ISingleControlContainerBase::setCurrentTab(int newTab) {
	if (newTab>=0 && newTab<this->numberOfTab) {
		if (this->currentTab != newTab) {
			this->currentTab = newTab;
			Redraw();
			return true;
		}
	}
	return false;
}



void ISingleControlContainerBase::setDisable() {
	if (!mGrayed) {
		mGrayed = true;
		SetDirty(false);
	}
}
void ISingleControlContainerBase::setEnable() {
	if (mGrayed) {
		mGrayed = false;
		SetDirty(true);
	}
}


