#pragma once

#include "IPLugNrpn.h"
#include "IControl.h"


class ISingleControlContainerBase : public IControl
{
public:
	ISingleControlContainerBase::ISingleControlContainerBase(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn, IRECT rect, int numberOfTab);

	ISingleControlContainerBase::ISingleControlContainerBase(IPlugBase* pPlugBase, IPlugNrpn* pPlugNrpn,  int x, int y, IBitmap* pBitmap, int numberOfTab);

	// return true if the new tab is different from the currentOne
	virtual bool setCurrentTab(int newTab);

	virtual void flushNrpn() = 0;

	virtual void setValueFromAutomation(int controlNumber, double value) = 0;
	virtual void setValueFromHardware(int tab, int controlNumber, int nrpnValue) = 0;

	virtual float getFloatFromNrpn(int nrpnValue) = 0;
	virtual float getFloatFromInternal(int intValue) = 0;
	virtual int   getInternalFromFloat(float value) = 0;
	virtual int   getNrpnFromInternal(int intValue) = 0;

	void setDisable();
	void setEnable() ;


protected:
	IBitmap mBitmap;
	IPlugNrpn* nrpnPlug;

	// deal with multiple tabs
	int numberOfTab;
	int currentTab;

	// Colors
	static const IColor darkBlue;
	static const IColor white;
	static const IColor darkYellow;
	static const IColor yellow;
	static const IColor gray;
	static const IColor shadow;
};


