#pragma once
#include "IControl.h"
#include "ISingleControl.h"
#include "IMultipleControlContainer.h"

#define NUMBER_OF_STEPS 16

class IStepSequencer : public IMultipleControlContainer
{
	friend class IADSROneValue;
public:
	IStepSequencer(IPlugBase* pPlugBase,IPlugNrpn* pPlugNrpn, IGraphics* pGraphics, IRECT rect, int firstParam, int numerOfTab);
	~IStepSequencer(void);

    bool Draw(IGraphics* pGraphics);
	void OnMouseDown(int x, int y, IMouseMod* pMod);
	void OnMouseDblClick(int x, int y, IMouseMod* pMod);
	void OnMouseDrag(int x, int y, int dX, int dY, IMouseMod* pMod);
	void OnMouseUp(int x, int y, IMouseMod* pMod);
	void OnMouseWheel(int x, int y, IMouseMod* pMod, int d);

	// Implements abstract method
	int getNrpnParam(int currentTab, int controlNumber) ;
	int getParamId(int currentTab, int controlNumber) ;
	float getFloatFromNrpn(int nrpnValue) ;
	float getFloatFromInternal(int intValue) ;
	int   getInternalFromFloat(float value) ;
	int   getNrpnFromInternal(int intValue) ;

private:
	int drag ;
	int firstParam;
	int sizeStepX, sizeStepY;
};
